<?xml version="1.0" encoding="utf-8"?>
<xsl:stylesheet version="1.0"
	xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
	xmlns='http://www.w3.org/2002/12/cal/ical#'
	xmlns:i='http://www.w3.org/2002/12/cal/ical#'
	xmlns:x='http://www.w3.org/2002/12/cal/prod/Apple_Comp_273def595c8b3485#'
	xmlns:rss="http://purl.org/rss/1.0/"
	xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#"
	xmlns:rdfs="http://www.w3.org/2000/01/rdf-schema#"
	xmlns:contact="http://www.w3.org/2000/10/swap/pim/contact#"
	xmlns:foaf="http://xmlns.com/foaf/0.1/"
	xmlns:dc ="http://purl.org/dc/elements/1.1/"
	xmlns:dcterms="http://purl.org/dc/terms/"
	xmlns:trackback="http://madskills.com/public/xml/rss/module/trackback/"
	xmlns:date="http://exslt.org/dates-and-times"
	extension-element-prefixes="date i"
>

<!--
	iCalendar 由来の，連続したイベントや定期的なイベントを，1 日単位に展開する XSLT 
	毎月のイベントは対応しても，毎週のイベントには対応していない
	
-->


<!-- 2004-11-24T20:57 毎月あるイベントの処理の不具合を修正 -->
<!-- 2005-03-03T16:11:29 祝日用に修正 -->

<xsl:output 
	method="text"
	encoding="utf-8"
	indent="yes"
/> 

<xsl:variable name="now2" select="date:date-time()"/>
<xsl:variable name="now1" select="'2006-01-01T00:00:00+09:00'"/>
<xsl:variable name="br" select="'
'"/>

<xsl:template match="/">
	<xsl:text>@charset "utf-8";</xsl:text>
	<xsl:apply-templates select="rdf:RDF/i:Vcalendar|rdf:RDF/i:vcalendar"/>
</xsl:template>

<xsl:template match="i:Vcalendar|i:vcalendar">
	<xsl:for-each select="i:component/i:Vevent|i:component/i:vevent">
	<xsl:sort select="substring-after(i:dtstart/i:date|i:dtstart/i:dateTime,'-')"/>
		<xsl:choose>
			<xsl:when test="i:rrule/i:byday">
				<xsl:text>
#b</xsl:text>
				<xsl:call-template name="monday">
					<xsl:with-param name="date1">
						<xsl:value-of select="concat(substring-before($now,'-'),concat(substring(i:dtstart/i:date,5,3),'-01'))"/>
					</xsl:with-param>
					<xsl:with-param name="num"><xsl:value-of select="substring-before(i:rrule/i:byday,'M')"/></xsl:with-param>
				</xsl:call-template>
				<xsl:text>{background-color: #FFC0C0; color: #000000; /*</xsl:text>
				<xsl:value-of select="i:summary"/>
				<xsl:text>*/}</xsl:text>
			</xsl:when>
			<xsl:when test="string(i:rrule/i:freq)= 'YEARLY'">
				<xsl:text>
#b</xsl:text>
				<xsl:value-of select="substring-before($now,'-')"/>
				<xsl:value-of select="translate(substring-after(i:dtstart/i:date,'-'),'-','')"/>
				<xsl:text>{background-color: #FFC0C0; color: #000000; /*</xsl:text>
				<xsl:value-of select="i:summary"/>
				<xsl:text>*/}</xsl:text>
			</xsl:when>
			<xsl:when test="starts-with(i:dtstart/i:date, substring-before($now,'-'))" >
				<xsl:text>
#b</xsl:text>
				<xsl:value-of select="substring-before(i:dtstart/i:date,'-')"/>
				<xsl:value-of select="translate(substring-after(i:dtstart/i:date,'-'),'-','')"/>
				<xsl:text>{background-color: #FFC0C0; color: #000000; /*</xsl:text>
				<xsl:value-of select="i:summary"/>
				<xsl:text>*/}</xsl:text>
			</xsl:when>
		</xsl:choose>
	</xsl:for-each>
</xsl:template>

<xsl:template name="monday">
	<xsl:param name="date1" select='"2005-01-01"' />
	<xsl:param name="num" select='"1"' />
	<xsl:choose>
		<xsl:when test='date:day-in-week($date1) != 2'>
			<xsl:call-template name="monday">
				 <xsl:with-param name="date1"><xsl:value-of select="date:add($date1,'P1D')"/></xsl:with-param>
				<xsl:with-param name="num"><xsl:value-of select="$num"/></xsl:with-param>
			</xsl:call-template>
		</xsl:when>
		<xsl:when test='not(date:day-of-week-in-month($date1) = $num)'>
			<xsl:call-template name="monday">
				 <xsl:with-param name="date1"><xsl:value-of select="date:add($date1,'P1D')"/></xsl:with-param>
				<xsl:with-param name="num"><xsl:value-of select="$num"/></xsl:with-param>
			</xsl:call-template>
		</xsl:when>
		<xsl:otherwise>
			<xsl:value-of select="translate($date1,'-','') "/>
		</xsl:otherwise>
	</xsl:choose>

</xsl:template>

</xsl:stylesheet> 