#!/bin/sh
# ONO Hiroki onohiroki@cup.com 2008-02-13
# http://onohiroki.cycling.jp/comp-ical-xslt.html
# 自由に改変して配布してください．

# 必要なファイル
#     任意の iCalendar ファイル
#     祝日のファイル Japanese32Holidays.ics "http://homepage.mac.com/ical/.calendars/Japanese32Holidays.ics"
#     Jcode.pm "http://openlab.ring.gr.jp/Jcode/index-j.html"
#     ical2rdf.pl "http://www.w3.org/2002/12/cal/ical2rdf.pl"

# iCalendar ファイルのファイルを RDF/XML に変換してから XSLT で Microformats に対応した XHTML に変換します．

# ics ファイルのコピー
curl -o cycling-event.ics "http://ical.mac.com/WebObjects/iCal.woa/wa/Download/cycling-event.ics?u=onohiroki&n=cycling-event.ics"
curl -o Japanese32Holidays.ics "http://homepage.mac.com/ical/.calendars/Japanese32Holidays.ics"

# 祝日の情報を CSS に変換
./ical2rdf.pl Japanese32Holidays.ics  > Holidays.rdf.xml
xsltproc --stringparam now `date +%Y-01-01` holidays2css.xsl Holidays.rdf.xml > `date +holidays%Y.css`

thisyear=`date +%Y`
nextyear=`expr $thisyear + 1`
xsltproc --stringparam now "$thisyear-01-01" holidays2css.xsl Holidays.rdf.xml > "holidays$thisyear.css"
xsltproc --stringparam now "$nextyear-01-01" holidays2css.xsl Holidays.rdf.xml > "holidays$nextyear.css"


./ical2rdf.pl cycling-event.ics > cycling-event-cal.rdf
cat cycling-event-cal.rdf | ./untildate.pl | ./fixcomma.pl > cycling-event-cal1.xml

# RDF Calender の繰り返しイベントを個々のイベントに展開
xsltproc rical2rical.xsl cycling-event-cal1.xml > cycling-event-cal2.xml
xsltproc ricalfix.xsl cycling-event-cal2.xml > current-cycling-event-cal.tmp

# カレンダー情報を RSS 1.0 に変換
xsltproc rical2rss.xsl current-cycling-event-cal.tmp > current-cycling-event-rss.tmp

# tmp を RDF へ変換
./nsfix.pl < current-cycling-event-cal.tmp > current-cycling-event-cal.rdf
rm current-cycling-event-cal.tmp
./nsfix.pl < current-cycling-event-rss.tmp > current-cycling-event-rss.rdf
rm current-cycling-event-rss.tmp;

# カレンダー情報を XHTML に変換
xsltproc rical2htmln00.xsl current-cycling-event-cal.rdf > calendar.html

# カレンダー情報を TEXT としてシェルスクリプトに変換
# XSLT で RDF から XHTML に変換
xsltproc 2sh.xsl current-cycling-event-cal.rdf > gen-calendars.txt
source gen-calendars.txt

# カレンダー情報を Javascript に変換
xsltproc rss2javascript.xsl current-cycling-event-rss.rdf > current-cycling-event.js
# nkf -W -e current-cycling-event.js > current-cycling-event.js.euc
# nkf -W -j current-cycling-event.js > current-cycling-event.js.jis
# nkf -W -s current-cycling-event.js > current-cycling-event.js.sjis

# ファイルのコピーとアップロード
mv *.html Site/
mv *.css Site/
mv *.js Site/
mv *.js.* Site/
cp *.ics Site/
mv *.rdf Site/
rm Site/Japanese32Holidays.ics
rm Site/current-cycling-event-cal.rdf 
cp Site/calendar.css .

echo "done."

