<?xml version="1.0" encoding="utf-8"?>
<xsl:stylesheet version="1.0"
	xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
	xmlns="http://www.w3.org/1999/xhtml"
	xmlns:rss="http://purl.org/rss/1.0/"
	xmlns:i='http://www.w3.org/2002/12/cal/ical#'
	xmlns:x='http://www.w3.org/2002/12/cal/prod/Apple_Comp_273def595c8b3485#'
	xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#"
	xmlns:rdfs="http://www.w3.org/2000/01/rdf-schema#"
	xmlns:contact="http://www.w3.org/2000/10/swap/pim/contact#"
	xmlns:content="http://purl.org/rss/1.0/modules/content/"
	xmlns:xhtml="http://www.w3.org/1999/xhtml"
	xmlns:foaf="http://xmlns.com/foaf/0.1/"
	xmlns:dc ="http://purl.org/dc/elements/1.1/"
	xmlns:dcterms="http://purl.org/dc/terms/"
	xmlns:trackback="http://madskills.com/public/xml/rss/module/trackback/"
	xmlns:date="http://exslt.org/dates-and-times"
	extension-element-prefixes="date rss i x rdf rdfs contact content xhtml foaf dc dcterms trackback "
>

<xsl:output 
	method="xml"
	doctype-public="-//W3C//DTD XHTML 1.1//EN"
	doctype-system="http://www.w3.org/TR/xhtml11/DTD/xhtml11.dtd"
	encoding="utf-8"
	indent="yes"
/> 

<xsl:variable name="now" select="date:date-time()"/>
<xsl:variable name="day" select="$now"/>
<xsl:variable name="mm" select="date:month-in-year($day)"/>
<xsl:variable name="beginningmonth" select="concat(substring($day,1,8),'01')"/>

<xsl:template match="/rdf:RDF">
<html xml:lang="ja">
<head>
	<meta http-equiv="Content-Type" content="text/html; charset=UTF-8" />
	<title>イベントカレンダー</title>
	<link rel="stylesheet" href="calendar.css" type="text/css" />
	<link rel="meta" type="application/rdf+xml" title="RDF Calender"  href="cycling-event-cal.rdf" />
	<link rel="meta" type="text/calendar" title="iCalender"  href="cycling-event.ics" />
	<meta name="author" content="Hiroki ONO" />
</head>
<body>
	<h1>イベントカレンダー</h1>
	<p>iCal で管理しているスケジュールから，公開できるイベント情報を提供します．</p>
	<xsl:call-template name="metadatalist">
		<xsl:with-param name="h2">yes</xsl:with-param>
		<xsl:with-param name="description">yes</xsl:with-param>
		<xsl:with-param name="ical">yes</xsl:with-param>
	</xsl:call-template>
	<h2>カレンダー</h2>
		<ul class="navi" id="calnavi">
		<li><a><xsl:attribute name="href">cal<xsl:value-of select="substring(date:add($day,'-P1M'),1,7)"/>.html#calnavi</xsl:attribute>
			<xsl:attribute name="title">
				<xsl:value-of select="date:month-in-year(date:add($day,'-P1M'))"/>
				<xsl:text> </xsl:text>月
			</xsl:attribute>先月</a>
		</li>
		<li><a><xsl:attribute name="href">cal<xsl:value-of select="substring($day,1,7)"/>.html#calnavi</xsl:attribute>
			<xsl:attribute name="title">
				<xsl:value-of select="date:month-in-year($day)"/>
				<xsl:text> </xsl:text>月
			</xsl:attribute>今月</a>
		</li>
		<li><a><xsl:attribute name="href">cal<xsl:value-of select="substring(date:add($day,'P1M'),1,7)"/>.html#calnavi</xsl:attribute>
			<xsl:attribute name="title">
				<xsl:value-of select="date:month-in-year(date:add($day,'P1M'))"/>
				<xsl:text> </xsl:text>月
			</xsl:attribute>来月</a>
		</li>
	</ul>

	<table class="ical" title="イベントカレンダー" summary ="イベントカレンダー．1列目が月曜日，2列目が火曜日，3列目が水曜日，4列目が木曜日，5列目が金曜日，6列目が土曜日，7列目が日曜日">
	<caption><xsl:value-of select="date:year($day)"/> 年 <xsl:value-of select="$mm"/> 月のイベントカレンダー</caption> 
	<thead>
	<tr><th class="mon">月</th><th class="tue">火</th><th class="wed">水</th><th class="thu">木</th><th class="fri">金</th><th class="sat">土</th><th class="sun">日</th></tr>
	</thead>
	<tbody>
	<xsl:call-template name="caltable"/>
	</tbody>
	</table>
</body>
</html>
</xsl:template>


<xsl:include href="rical2html.xsl"/>

</xsl:stylesheet> 