<?xml version="1.0" encoding="utf-8"?>
<!-- ONO Hiroki http://onohiroki.cycling.jp/xsl/rss2javascript.xsl -->
<xsl:stylesheet version="1.0"
	xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
	xmlns:rss="http://purl.org/rss/1.0/"
	xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#"
	xmlns:rdfs="http://www.w3.org/2000/01/rdf-schema#"
	xmlns:contact="http://www.w3.org/2000/10/swap/pim/contact#"
	xmlns:foaf="http://xmlns.com/foaf/0.1/"
	xmlns:dc ="http://purl.org/dc/elements/1.1/"
	xmlns:dcterms="http://purl.org/dc/terms/"
	xmlns:trackback="http://madskills.com/public/xml/rss/module/trackback/"
	xmlns:date="http://exslt.org/dates-and-times"
	xmlns:i='http://www.w3.org/2002/12/cal/ical#'
	xmlns:x='http://www.w3.org/2002/12/cal/prod/Apple_Comp_273def595c8b3485#'
	extension-element-prefixes="i x date rss rdf rdfs contact foaf dc dcterms trackback"
>
<xsl:output 
	method="html"
	encoding="ISO-2022-JP"
	indent="yes"
/> 

<xsl:variable name="now1" select="date:date-time()"/>
<xsl:variable name="now" select="date:add($now1,'-P3D')"/>

<xsl:template match="rdf:RDF">
	<div id="off-info-list">
	<h4><a href="calendar/" title="iCalender を利用した自転車関係のイベントカレンダー">サイクリング・オフラインミーティングの予定</a></h4>
	<ul>
	<xsl:call-template name="rssitem">
		<xsl:with-param name="num" select="1" />
		<xsl:with-param name="item" select="0" />
	</xsl:call-template>
	</ul>
	<ul>
	<li><span class="logo_XML">XML</span> 
<a href="calendar/current-cycling-event-rss.rdf"  title="RSS feed for Event Calendar">RSS</a></li>
	</ul>
	</div>
</xsl:template>

<xsl:template name="rssitem">
	<xsl:param name="num" select="$num" />
	<xsl:param name="item" select="$item" />
	<xsl:choose>
	<xsl:when test="$num &gt; count(rss:item)"/>
	<xsl:when test="$item &gt; 5"/>

	<xsl:when test="contains(date:difference(rss:item[$num]/foaf:topic/i:Vevent/i:dtstart/i:date|rss:item[$num]/foaf:topic/i:Vevent/i:dtstart/i:dateTime,$now), '-P')">
	<li class="venent"><!-- rssitem -->
	<a>
	<xsl:attribute name="href"><xsl:value-of select="rss:item[$num]/rss:link"/></xsl:attribute>
		<abbr class="dtstart">
		<xsl:attribute name="title"><xsl:value-of select="substring(rss:item[$num]/foaf:topic/i:Vevent/i:dtstart/i:date|rss:item[$num]/foaf:topic/i:Vevent/i:dtstart/i:dateTime,1,10)"/></xsl:attribute>
		<xsl:value-of select="substring(rss:item[$num]/foaf:topic/i:Vevent/i:dtstart/i:date|rss:item[$num]/foaf:topic/i:Vevent/i:dtstart/i:dateTime,6,2)"/>/<xsl:value-of select="substring(rss:item[$num]/foaf:topic/i:Vevent/i:dtstart/i:date|rss:item[$num]/foaf:topic/i:Vevent/i:dtstart/i:dateTime,9,2)"/>
		</abbr>
	</a>
	<xsl:text> </xsl:text>
	<a class="url"><xsl:attribute name="href"><xsl:value-of select="rss:item[$num]/@rdf:about"/></xsl:attribute>
	<span class="summary"><xsl:value-of select="rss:item[$num]/foaf:topic/i:Vevent/i:summary"/></span>
	</a>
	</li>
		<xsl:call-template name="rssitem">
			<xsl:with-param name="num" select="1+$num" />
			<xsl:with-param name="item" select="1+$item" />
		</xsl:call-template>
	</xsl:when>
	
	<xsl:otherwise>
		<xsl:call-template name="rssitem">
			<xsl:with-param name="num" select="1+$num" />
			<xsl:with-param name="item" select="$item" />
		</xsl:call-template>
	</xsl:otherwise>
	</xsl:choose>
</xsl:template>

</xsl:stylesheet>
 